package com.integ.mqtt.messagehandlers;

import com.integpg.janoslib.io.AppLog;
import java.util.Json;
import com.integ.janoslib.messagepump.MessagePumpAppMessageListener;
import com.integ.mqtt.MqttMain;
import com.integpg.janoslib.mqtt.QualityOfService;
import com.integpg.janoslib.mqtt.SubscribeOptions;
import com.integpg.janoslib.mqtt.SubscribeTopic;
import com.integpg.janoslib.utils.StringUtils;

public class SubscribeEventHandler implements MessagePumpAppMessageListener {

    @Override
    public void applicationMessageReceived(Json commandJson) {
        String[] topicsArray = null;

        try {
            SubscribeOptions subscribeOptions = new SubscribeOptions();

            // get the topics
            topicsArray = (String[]) commandJson.get("Topics");
            if (null == topicsArray || 0 == topicsArray.length)
                throw new IllegalArgumentException("MQTT Topic must not be null in MQTT Message");

            String topicsArrayString = String.format("[%s]", StringUtils.join(topicsArray, ","));
            System.out.println("subscribe to " + topicsArrayString);

            for (String topicString : topicsArray) {
                SubscribeTopic subscribeTopic = new SubscribeTopic(topicString, QualityOfService.AT_LEAST_ONCE);
                subscribeOptions.addTopic(subscribeTopic);
            }

            MqttMain.getInstance().MqttClient.subscribe(subscribeOptions);
        } catch (Exception ex) {
            String topicsArrayString = String.format("[%s]", StringUtils.join(topicsArray, ","));
            AppLog.error("error subscribing to " + topicsArrayString, ex);
        }
    }

}

